Request

Response

    Get All Applications
    GET

    clients

    Get a list of all APS applications. Only applications that the current user owns or is a collaborator on will be returned.

    Resource Information

    Method and URI
    GET
    https://developer.api.autodesk.com/applications/v1/clients
    Authentication Context
    User context required
    Required OAuth Scopes
    application:client:read
    Data Format
    JSON

    Request

    Headers

    Authorization*
    string
    Must be Bearer <token>, where <token> is a three-legged access token obtained via an Authorization Code flow or a Secure Service Account (SSA) flow.

    The SSA flow is designed for headless server-to-server operations. While it functions like a two-legged flow (no user interaction), it is classified as three-legged because it preserves user context.

    * Required

    Request

    Query String Parameters

    limit
    int
    The maximum number of results to return in a single page.

    Response

    HTTP Status Code Summary

    200
    OK
    Successful retrieval of all APS applications that the current user has access to as an owner or collaborator.
    401
    Unauthorized
    The request did not have a valid access token. Obtain a fresh access token and try again.
    403
    Forbidden
    You do not have permission to perform the operation specified by the request.
    404
    Not Found
    No applications found.

    Response

    Body Structure (200)

    Expand all
    pagination
    object
    Specifies if the response has been split in to multiple pages, and if so the details.
    limit
    number
    The limit value supplied in the request.
    nextUrl
    string
    Link that will return the next page of data. If not included, this is the last page of data.
    previousUrl
    string
    Link that will return the previous page of data. If the previous link is being returned then absence indicates this being the first page.
    results
    array: object
    An array of objects where each object contains the details of an APS application.
    name
    string
    The name of the application, as registered with APS

    Max length: 80

    description
    string
    The description of the application, as registered with APS.

    Max length: 2000

    jwksUri
    string
    The JSON Web Keyset (JWKS) URI of the application, as registered with APS. Use the JWKS URI to verify client assertion during secret rotation.

    Max length: 255

    callbackUris
    array: string
    The list of Callback URLs registered with APS for this application. APS uses these URLs to redirect users back to the application during a 3-legged authorization process.

    For WEB and PUBLIC applications, at least one callback URL is required.

    apiProductIds
    array: string
    The list of API Products the application is allowed to access. Refer to the listApiProducts operation for more details.
    contextId
    string
    The context (team) ID.
    id
    string
    The client ID of the application.

    Max length: 200

    createdAt
    datetime: ISO 8601
    The date and time at which the application was registered.
    updatedAt
    datetime: ISO 8601
    The date and time at which the application’s settings were last modified.
    oAuthFlows
    array: object
    issuer
    string
    The OAuth issuer
    clientType
    enum:string
    Possible values are:
    • CONFIDENTIAL - Client with a client_secret capable of maintaining confidentiality.
    • PUBLIC - Client not capable of maintaining confidentiality (such as a desktop app, mobile, or single-page web app).
    grantType
    enum:string
    Possible values are:
    • AUTHORIZATION_CODE - The Authorization Code grant type.
    • CLIENT_CREDENTIALS - The Client Credentials grant type.
    pkce
    enum:string
    Possible values are:
    • REQUIRED - PKCE is required for the flow.
    • OPTIONAL - PKCE is optional for the flow.
    • UNSUPPORTED - PKCE is not supported for the flow.
    secretCreatedAt
    datetime: ISO 8601
    The data and time at which the application’s client secret was last rotated.
    preparedSecretExpiresAt
    datetime: ISO 8601
    The date and time the prepared client secret for this application expires. This secret is generated by the Prepare Secret Rotation operation. If no prepared secret exists, preparedSecretExpiresAt is null.
    owner
    object
    Details of the user who owns the application.
    userId
    string
    The owner’s user ID.

    Max length: 100

    firstName
    string
    The owner’s first name.

    Max length: 150

    lastName
    string
    The owner’s last name

    Max length: 150

    email
    string
    The owner’s email address.

    Max length: 254

    Example

    Successful retrieval of all APS applications that the current user has access to as an owner or collaborator.

    Request

    curl -v 'https://developer.api.autodesk.com/applications/v1/clients' \
      -H 'Authorization: Bearer AuIPTf4KYLTYGVnOHQ0cuolwCW2a'
    

    Response

    {
      "pagination": {
        "limit": 100,
        "nextUrl": "https://developer.api.autodesk.com/~NEXT_PAGE~",
        "previousUrl": "https://developer.api.autodesk.com/~PREVIOUS_PAGE~"
      },
      "results": [
        {
          "name": "Internet Widgits Pty Ltd",
          "description": "Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vivamus vel facilisis ex. Nullam lobortis id lectus ac rutrum.\n",
          "jwksUri": "https://example.com/.well-known/jwks.json",
          "callbackUris": [
            "https://example.com/oauth/callback"
          ],
          "apiProductIds": [
            "66002353-96e9-4296-aa1e-a172a0b431c7"
          ],
          "contextId": "urn:adsk.aum:prd:tenant.oxygenId:12345678",
          "id": "pWPf8f2U2rWJfPgRnj3TnUCKHASOZJpp",
          "createdAt": "2019-01-01T00:00:00Z",
          "updatedAt": "2019-01-01T00:00:00Z",
          "oAuthFlows": [
            {
              "issuer": "https://developer.api.autodesk.com",
              "clientType": "CONFIDENTIAL",
              "grantType": "AUTHORIZATION_CODE",
              "pkce": "OPTIONAL"
            }
          ],
          "secretCreatedAt": "",
          "preparedSecretExpiresAt": "2019-01-01T00:00:00Z",
          "owner": {
            "userId": "389JJQ8PJSMJ",
            "firstName": "Ada",
            "lastName": "Lovelace",
            "email": "ada.lovelace@example.com"
          }
        }
      ]
    }
    
    Show More